5 # Shell script to build Makefile in a build directory. It must be called
6 # from inside the directory. It does its own checking of when to rebuild; it
7 # just got too horrendous to get it right in "make", because of the optionally
8 # existing configuration files.
10 # Copyright (c) The Exim Maintainers 1995 - 2020
13 # First off, get the OS type, and check that there is a make file for it.
15 ostype=`../scripts/os-type -generic` || exit 1
17 if [ ! -r ../OS/Makefile-$ostype ] ; then
19 echo "*** Sorry - operating system $ostype is not supported"
20 echo "*** See OS/Makefile-* for supported systems" 1>&2
25 # We also need the architecture type, in order to test for any architecture-
26 # specific configuration files.
28 archtype=`../scripts/arch-type` || exit 1
30 # Now test for either the non-existence of Makefile, or for any of its
31 # components being newer. Note that the "newer" script gives the right
32 # answer (for our purposes) when the first file is non-existent.
34 editme=../Local/Makefile
37 if [ -f Makefile ] ; then
39 if ../scripts/newer $editme Makefile || \
40 ../scripts/newer $editme-$ostype Makefile || \
41 ../scripts/newer $editme-$archtype Makefile || \
42 ../scripts/newer $editme-$ostype-$archtype Makefile || \
43 ../scripts/newer ../scripts/Configure-Makefile Makefile || \
44 ../scripts/newer ../OS/Makefile-Base Makefile || \
45 ../scripts/newer ../OS/Makefile-Default Makefile
51 # If the "build" variable is set it means that a build name was explicitly
52 # given. Arrange to pick up a build-specific configuration file.
54 if [ "X$build" != "X" ] ; then
55 mfb=Local/Makefile-$build
56 if ../scripts/newer $editme-$build Makefile ; then
64 # If Makefile is up-to-date, no need to rebuild it.
66 if [ $rebuild = no ] ; then
67 echo "\`Makefile' is up to date."
72 # Makefile needs to be rebuilt in the current directory by joining
73 # the generic default makefile, the OS base makefile, and then local
74 # generic, OS-specific, architecture-specific, and OS+architecture-specific
75 # makefiles, if they exist. These files all contain macro definitions, with
76 # later definitions overriding earlier ones. Make a temporary file first, in
77 # case things go wrong. A second temporary is needed for sorting out the
78 # default Perl stuff. Use short macro names to save typing.
86 look_mf=lookups/Makefile
87 look_mf_pre=${look_mf}.predynamic
88 look_mf_post=${look_mf}.postdynamic
90 # Ensure the temporary does not exist and start the new one by setting
91 # the OSTYPE and ARCHTYPE variables.
93 rm -f $mft $mftt $mftepcp $mftepcp2 $look_mf-t
94 (echo "OSTYPE=$ostype"; echo "ARCHTYPE=$archtype"; echo "") > $mft || exit 1
96 # Now concatenate the files to the temporary file. Copy the files using sed to
97 # remove comments, blank lines, and trailing white space.
99 # BEWARE: a tab character is needed in the sed command below. It has had
100 # a nasty tendency to get lost in the past, causing a problem if a tab has
101 # actually been present in one of the files. Use a variable to hold a space
102 # and a tab to keep the tab in one place.
106 for f in OS/Makefile-Default \
107 OS/Makefile-$ostype \
109 Local/Makefile-$ostype \
110 Local/Makefile-$archtype \
111 Local/Makefile-$ostype-$archtype \
114 then echo "# From $f"
115 sed "/^#/d;/^[$st]*\$/d;s/[$st]*\$//" ../$f || exit 1
120 | sed 's/^TMPDIR=/EXIM_&/' \
123 # handle PKG_CONFIG_PATH because we need it in our env, and we want to handle
124 # wildcards; note that this logic means all setting _appends_ values, never
125 # replacing; if that's a problem, we can revisit.
126 sed -n "s/^[$st]*PKG_CONFIG_PATH[$st]*[+]*=[$st]*//p" $mft | \
127 sed "s/[$st]*\$//" >> $mftepcp
128 if test -s ./$mftepcp
130 # expand any wildcards and strip spaces, to make it a real PATH-like variable
131 ( IFS=":${IFS-$st}"; for P in `cat ./$mftepcp`; do echo "$P"; done ) | xargs | sed "s/[$st]/:/g" >./$mftepcp2
132 sed "s/^/PKG_CONFIG_PATH='/" < ./$mftepcp2 | sed "s/\$/'/" > ./$mftepcp
134 export PKG_CONFIG_PATH
135 egrep -v "^[$st]*PKG_CONFIG_PATH[$st]*=" ./$mft > ./$mftt
138 echo "# Collapsed PKG_CONFIG_PATH in build-prep:"
139 sed "s/'//g" ./$mftepcp
140 echo "# End of collapsed PKG_CONFIG_PATH"
146 rm -f ./$mftepcp ./$mftepcp2
149 # beware portability of extended regexps with sed.
150 egrep "^[$st]*(AUTH|LOOKUP)_[A-Z0-9_]*[$st]*=[$st]*" $mft | \
151 sed "s/[$st]*=/='/" | \
152 sed "s/\$/'/" > $mftt
153 egrep "^[$st]*((USE_(OPENSSL|GNUTLS)_PC)|SUPPORT_TLS|USE_GNUTLS|PCRE_CONFIG|AVOID_GNUTLS_PKCS11)[$st]*=[$st]*" $mft | \
154 sed "s/[$st]*=/='/" | \
155 sed "s/\$/'/" >> $mftt
159 echo "# pkg-config fixups"
161 for var in `cut -d = -f 1 < $mftt`; do
165 eval "pc_value=\"\$$var\""
168 if [ ".$DISABLE_TLS" = .yes ]; then
169 # no TLS, not referencing
171 elif [ ".$var" = ".USE_GNUTLS_PC" ] && [ ".$USE_GNUTLS" != "." ]; then
173 need_core="gnutls-special"
174 elif [ ".$var" = ".USE_OPENSSL_PC" ] && [ ".$USE_GNUTLS" = "." ]; then
178 if [ ".$need_this" != "." ]; then
179 tls_include=`pkg-config --cflags $pc_value`
180 if [ $? -ne 0 ]; then
181 echo >&2 "*** Missing pkg-config for package $pc_value (for Exim $var build option)"
184 tls_libs=`pkg-config --libs $pc_value`
185 echo "TLS_INCLUDE=$tls_include"
186 echo "TLS_LIBS=$tls_libs"
187 # With hash.h pulling crypto into the core, we need to also handle that
188 if [ ".$need_this" = ".t" ]; then
189 echo "CFLAGS += $tls_include"
190 echo "LDFLAGS += $tls_libs"
191 elif [ ".$need_this" = ".gnutls-special" ]; then
192 if pkg-config --atleast-version=2.10 gnutls ; then
193 echo "CFLAGS += $tls_include"
194 echo "LDFLAGS += $tls_libs"
196 echo "CFLAGS += `libgcrypt-config --cflags`"
197 echo "LDFLAGS += `libgcrypt-config --libs`"
204 eval "pc_value=\"\$$var\""
205 base=`echo $var | sed 's/_PC$//'`
206 eval "basevalue=\"\$$base\""
207 if [ ".$basevalue" = "." ]; then
208 # not pulling in this module, _PC defined as default? Ignore
210 elif [ $basevalue = 2 ]; then
211 # module; handled in scripts/lookups-Makefile
215 cflags=`pkg-config --cflags $pc_value`
216 if [ $? -ne 0 ]; then
217 echo >&2 "*** Missing pkg-config for package $pc_value (for Exim $var build option)"
220 libs=`pkg-config --libs $pc_value`
221 if [ "$var" != "${var#LOOKUP_}" ]; then
222 echo "LOOKUP_INCLUDE += $cflags"
223 echo "LOOKUP_LIBS += $libs"
224 elif [ "$var" != "${var#AUTH_}" ]; then
225 echo "CFLAGS += $cflags"
226 echo "AUTH_LIBS += $libs"
228 echo >&2 "Don't know how to handle pkg-config for $var"
236 cflags=`pcre-config --cflags`
237 if [ $? -ne 0 ]; then
238 echo >&2 "*** Missing pcre-config for regular expression support"
241 libs=`pcre-config --libs`
242 if [ ".$cflags" != "." ]; then
243 echo "INCLUDE += $cflags"
245 echo "PCRE_LIBS=$libs"
256 echo "# End of pkg-config fixups"
260 if [ $subexit -ne 0 ]; then
266 # make the lookups Makefile with the definitions
267 # the auxiliary script generates $look_mf_post from $look_mf_pre
269 cp ../src/lookups/Makefile $look_mf_pre
270 ../scripts/lookups-Makefile
272 # See if there is a definition of EXIM_PERL in what we have built so far.
273 # If so, run Perl to find the default values for PERL_CC, PERL_CCOPTS,
274 # and PERL_LIBS. These need to be put at the top of the Makefile, so we rename
275 # what we have so far and then copy it afterwards. Use the value of PERL_COMMAND
276 # if it has been defined.
278 EXIM_PERL=`grep EXIM_PERL $mft`
280 PERL_COMMAND=`grep PERL_COMMAND $mft | sed -e "\\$!d;s/^[$st]*PERL_COMMAND[$st]*=[$st]*//"`
281 if [ "${PERL_COMMAND}" = "" ] ; then
285 if [ "${EXIM_PERL}" != "" ] ; then
286 testperl=`$PERL_COMMAND --version`
287 if [ "$testperl" = "" ] ; then
288 echo "*** EXIM_PERL is set, but '$PERL_COMMAND --version' failed"
292 EXTUTILS_EMBED_NOT_INSTALLED=`$PERL_COMMAND -MExtUtils::Embed -e ";" 2>&1`
293 if [ "${EXTUTILS_EMBED_NOT_INSTALLED}" != "" ] ; then
294 echo "Please install ExtUtils::Embed for $PERL_COMMAND"
299 echo "PERL_CC=`$PERL_COMMAND -MConfig -e 'print $Config{cc}'`" >>$mft
300 echo "PERL_CCOPTS=`$PERL_COMMAND -MExtUtils::Embed -e ccopts`" >>$mft
301 echo "PERL_LIBS=`$PERL_COMMAND -MExtUtils::Embed -e ldopts`" >>$mft
307 # Record the build variable in the Makefile.
309 echo "build=$build" >>$mft
312 # Finally, join on the generic base make file, which contains the actual
315 echo "# From ../OS/Makefile-Base" >> $mft
316 cat ../OS/Makefile-Base >> $mft || exit 1
318 # If the new makefile is the same as the existing one, say so, and just
319 # update the timestamp. Otherwise remove the old and install the new.
321 if [ -s $mf ] && cmp -s $mft $mf && [ -s $look_mf ] && cmp -s $look_mf_post $look_mf
322 then echo ">>> rebuilt $mf unchanged"
325 rm -f $mft $look_mf_pre $look_mf_post
326 elif rm -f $mf $look_mf $look_mf_pre
328 mv $look_mf_post $look_mf
329 then echo ">>> New $mf & $look_mf installed"
330 echo '>>> Use "make makefile" if you need to force rebuilding of the makefile'
333 echo "*** Failed to install $mf - see $mft"
334 echo " (or $look_mft)"
340 # End of Configure-Makefile